// -*- C++ -*-

// Interface for TestStr type. See TestByte.h
//
// jhrg 1/12/95

#ifndef _jgstr_h
#define _jgstr_h 1

#ifndef __POWERPC__
#ifdef __GNUG__
#pragma interface
#endif
#endif

#include "Str.h"

class JGStr: public Str {
private:
    string _missing_val;

public:
    JGStr(const string &n = (char *)0);
    virtual ~JGStr() {}

    virtual BaseType *ptr_duplicate();
    
    virtual bool read(const string &dataset);

    virtual string get_missing_value() const;
    virtual void set_missing_value(const string &v);
};

/* 
 * $Log: JGStr.h,v $
 * Revision 1.7.6.1  2003/06/26 09:22:14  rmorris
 * ifdef'd out usage of #pragma interface for OS_X.  That's not compatible
 * with dynamic typing under OS_X.
 *
 * Revision 1.7  2001/08/27 17:41:03  jimg
 * Merged with release-3-2-2
 *
 * Revision 1.6.4.1  2001/08/21 15:15:39  dan
 * Updated names of the set/get accessor methods for modifying the missing_value
 * member field, to make the naming convention consistent with the current
 * DAP usage.
 *
 * Revision 1.6  2000/10/10 23:36:14  jimg
 * Added exception processing code.
 * Added throws to the read methods.
 * Changed the definition of read to match the dap library.
 * Moved CVS Log entries to the end of files.
 *
 * Revision 1.5  1999/11/05 01:17:24  jimg
 * Result of merge with release-3-1-0
 *
 * Revision 1.4.6.1  1999/10/24 18:32:31  dan
 * Modified to support new missing_value attribute
 * handling.
 *
 * Revision 1.4  1999/05/05 04:38:00  brent
 * convert String.h code to new stanard lib <string>
 *
 * Revision 1.3  1996/09/17 00:02:18  jimg
 * Misc changes associated with merging branch code to the trunk.
 *
 * Revision 1.2.8.1.2.1  1996/06/26 22:18:05  jimg
 * Dans changes for 2.05.
 *
 * Revision 1.2  1995/03/14  01:23:42  jimg
 * Modified so that these files are a proper subclass of the DAP classes
 * Byte, ..., Grid.
 * Added assert macros.
 * Added Jgofs.h external declarations file.
 *
 * Revision 1.1  1995/02/16  19:14:07  dan
 * JGOFS sub-class definitions for Str.h
 *
 * Revision 1.2  1995/01/19  21:59:44  jimg
 * Added read_val from dummy_read.cc to the sample set of sub-class
 * implementations.
 * Changed the declaration of readVal in BaseType so that it names the
 * mfunc read_val (to be consistant with the other mfunc names).
 * Removed the unnecessary duplicate declaration of the abstract virtual
 * mfuncs read and (now) read_val from the classes Byte, ... Grid. The
 * declaration in BaseType is sufficient along with the decl and definition
 * in the *.cc,h files which contain the subclasses for Byte, ..., Grid.
 *
 * Revision 1.1  1995/01/19  20:20:55  jimg
 * Created as an example of subclassing the class hierarchy rooted at
 * BaseType.
 *
 */

#endif

